﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Threading;

namespace MVVM_Expand_Tree
{
    class ViewModel
    {
        
        public ObservableCollection<Company> Companies { get; set; }
        public RelayCommand buttonClick { get; set; }

        public ViewModel()
        {
            Companies = CreateList();
            buttonClick = new RelayCommand(ExpandAllNodes,true);
        }

        public void ExpandAllNodes(object obj)
        {
            var tree = (XamDataTree)obj;

            

            var areAllNodesExpanded = true;
            foreach(var node in tree.Nodes)
            {
                if (!node.IsExpanded) areAllNodesExpanded = false;
            }

            if (areAllNodesExpanded) CollapseAll(tree);
            else ExpandAll(tree);
        }

        #region Collapse&Expand Methods
        private void ExpandAll(XamDataTree tree)
        {
            foreach(var node in tree.Nodes)
            {
                node.IsExpanded = true;
            }
        }

        private void CollapseAll(XamDataTree tree)
        {
            foreach (var node in tree.Nodes)
            {
                node.IsExpanded = false;
            }
        }
        #endregion

        #region CreateData
        private ObservableCollection<Company> CreateList()
        {
            
            var John = new Employee("John Smith", 5250.50, 20, new DateTime(2008, 01, 01));
            var Hania = new Employee("Hania Dillard", 932874.22, 0, new DateTime(2012, 03, 17));
            var Devin = new Employee("Devin Burgess", 6944.10, -10, new DateTime(2016, 03, 22));
            var Arisha = new Employee("Arisha Woodcock", 57449.10, 15, new DateTime(2018, 11, 09));
            var Celia = new Employee("Celia Hogg", 123.50, -3, new DateTime(2011, 09, 11));
            var Payton = new Employee("Payton Carr", 656749.50, 4, new DateTime(2014, 12, 26));
            var Angela = new Employee("Angela Mclaughlin", 4894.50, 12, new DateTime(2005, 06, 30));
            var Ailsa = new Employee("Ailsa Curtis", 5587.50, -23, new DateTime(2013, 11, 21));
            var Oscar = new Employee("Oscar Hubbard", 3745.50, -17, new DateTime(1986, 09, 29));
            var Naeem = new Employee("Naeem Hall", 54892.50, 10, new DateTime(1993, 02, 17));
            var Kaeden = new Employee("Kaeden Vasquez", 56868.50, 3, new DateTime(1996, 12, 10));
            var Branden = new Employee("Branden Gregory", 4974.50, -6, new DateTime(2017, 12, 10));

            Company GoldenSky = new Company("Golden Sky");
            GoldenSky.HireEmployee(John);
            GoldenSky.HireEmployee(Hania);
            GoldenSky.HireEmployee(Devin);
            GoldenSky.HireEmployee(Arisha);
            Company SilverDuck = new Company("Silver Duck");
            SilverDuck.HireEmployee(Celia);
            SilverDuck.HireEmployee(Payton);
            SilverDuck.HireEmployee(Angela);
            Company MileniumFalcon = new Company("Millenium Falcon");
            MileniumFalcon.HireEmployee(Ailsa);
            MileniumFalcon.HireEmployee(Oscar);
            MileniumFalcon.HireEmployee(Naeem);
            MileniumFalcon.HireEmployee(Kaeden);
            MileniumFalcon.HireEmployee(Branden);

            ObservableCollection<Company> Companies = new ObservableCollection<Company>();
            Companies.Add(GoldenSky);
            Companies.Add(SilverDuck);
            Companies.Add(MileniumFalcon);
            return Companies;
        }

        #endregion
    }
}
